import React, { useState, useEffect, Fragment } from "react";
import logo from "./logo.svg";
import "./App.css";
import { TreeViewComponent } from "@syncfusion/ej2-react-navigations";
import LockIcon from "@material-ui/icons/Lock";
import Tooltip from "@material-ui/core/Tooltip";
import DoneIcon from "@material-ui/icons/Done";


function App() {
 
  const [treeViewFields, settreeViewData] = useState();
   useEffect(() => {
   var data=[
    {
      id: "39f156f5bebc978695cceafd73998663",
      type: "Application",
      spriteCssClass: "folder",
      expanded: true,
      text: "ApplicationNew",
      contextMenu: true,
      isMain: true,
      child: [
        {
          id: "39f157dd2293741dd9d3d34122f22ab1",
          type: "Module",
          text: "Account",
          expanded: false,
          spriteCssClass: "folder",
          contextMenu: true,
          isMain: false,
          allowAPI: false,
          isCodeGenerated: false,
          child: [
            {
              id: "39f157dde1846cbe9227d7d57ac65213",
              type: "Feature",
              spriteCssClass: "rootfolder",
              text: "Feature",
              contextMenu: false,
              isMain: false,
              allowAPI: true,
              isCodeGenerated: "1",
              isDeleted: false,
              displayIcon: "k-icon k-i-check",
              disbled: false,
              moduleId: "39f157dd2293741dd9d3d34122f22ab1",
              isCheckOut: true
            }
          ]
        },
        {
          id: "39f156f63683cbe9bd3d27011400cfa1",
          type: "Module",
          text: "Organization",
          expanded: false,
          spriteCssClass: "folder",
          contextMenu: true,
          isMain: false,
          allowAPI: false,
          isCodeGenerated: false,
          child: [
            {
              id: "39f156f666122032781f8d460ac6b3ad",
              type: "Feature",
              spriteCssClass: "rootfolder",
              text: "Sumeru",
              contextMenu: false,
              isMain: false,
              allowAPI: true,
              isCodeGenerated: "2",
              isDeleted: false,
              displayIcon: "k-icon k-i-check",
              disbled: false,
              moduleId: "39f156f63683cbe9bd3d27011400cfa1",
              isCheckOut: true
            },
            {
              id: "39f157009812129f4ffd11356ef9d17a",
              type: "Feature",
              spriteCssClass: "rootfolder",
              text: "Employee",
              contextMenu: false,
              isMain: false,
              allowAPI: true,
              isCodeGenerated: "2",
              isDeleted: false,
              displayIcon: "k-icon k-i-check",
              disbled: false,
              moduleId: "39f156f63683cbe9bd3d27011400cfa1",
              isCheckOut: true
            },
            {
              id: "39f1ec2db8cba2d60434ae79849810f5",
              type: "Feature",
              spriteCssClass: "rootfolder",
              text: "TestFeature",
              contextMenu: false,
              isMain: false,
              allowAPI: true,
              isCodeGenerated: "0",
              isDeleted: false,
              displayIcon: "k-icon k-i-check",
              disbled: false,
              moduleId: "39f156f63683cbe9bd3d27011400cfa1",
              isCheckOut: true
            },
            {
              id: "39f1ecc7f65b04437ea4a1ef60bff4bc",
              type: "Feature",
              spriteCssClass: "rootfolder",
              text: "TestUser",
              contextMenu: false,
              isMain: false,
              allowAPI: true,
              isCodeGenerated: "0",
              isDeleted: false,
              displayIcon: "k-icon k-i-check",
              disbled: false,
              moduleId: "39f156f63683cbe9bd3d27011400cfa1",
              isCheckOut: true
            },
            {
              id: "39f1ecdf71a7873cfab6562c42466ad0",
              type: "Feature",
              spriteCssClass: "rootfolder",
              text: "TestUser2",
              contextMenu: false,
              isMain: false,
              allowAPI: true,
              isCodeGenerated: "0",
              isDeleted: false,
              displayIcon: "k-icon k-i-check",
              disbled: false,
              moduleId: "39f156f63683cbe9bd3d27011400cfa1",
              isCheckOut: true
            },
            {
              id: "39f1ecf3cf78841f23518ea387ab5b9e",
              type: "Feature",
              spriteCssClass: "rootfolder",
              text: "Testuser3",
              contextMenu: false,
              isMain: false,
              allowAPI: true,
              isCodeGenerated: "0",
              isDeleted: false,
              displayIcon: "k-icon k-i-check",
              disbled: false,
              moduleId: "39f156f63683cbe9bd3d27011400cfa1",
              isCheckOut: true
            },
            {
              id: "39f1ed42c8e584db579293384a7ad6bf",
              type: "Feature",
              spriteCssClass: "rootfolder",
              text: "TestUser4",
              contextMenu: false,
              isMain: false,
              allowAPI: true,
              isCodeGenerated: "0",
              isDeleted: false,
              displayIcon: "k-icon k-i-check",
              disbled: false,
              moduleId: "39f156f63683cbe9bd3d27011400cfa1",
              isCheckOut: true
            },
            {
              id: "39f1ed433dbfd253c2df10ba42495b24",
              type: "Feature",
              spriteCssClass: "rootfolder",
              text: "TestUser5",
              contextMenu: false,
              isMain: false,
              allowAPI: true,
              isCodeGenerated: "0",
              isDeleted: false,
              displayIcon: "k-icon k-i-check",
              disbled: false,
              moduleId: "39f156f63683cbe9bd3d27011400cfa1",
              isCheckOut: false
            }
          ]
        }
      ]
    }
  ]

  var fields = {
    dataSource: data,
    id: "id",
    text: "text",
    hasChildren: "hasChild"
  }
  settreeViewData(fields);
  }, []);
 
 

  
  function nodeSelected(e) {
    console.log(e);
    var c = e.nodeData.text;
    console.log(c);
    
  }

 
  function codegeneratestatus(value) {
    var codegenerateStatus = value;
    if (codegenerateStatus == "0") {
      return <span className="codeGeneratedspan"></span>;
    } else if (codegenerateStatus == "1") {
      return (
        <span className="codeGeneratedspan">
          <Tooltip title="Code generated">
            <DoneIcon className="codeGenerated" />
          </Tooltip>
        </span>
      );
    } else if (codegenerateStatus == "2") {
      return (
        <span className="codeGeneratedspan">
          <Tooltip title="Feature modified after code generation">
            <DoneIcon className="codeGeneratedModified" />
          </Tooltip>
        </span>
      );
    } else {
      return <span></span>;
    }
  }
 

  function nodeTemplate(data) {
    console.log(data);

    return (
      <div>
        {data.isCheckOut ? (
          <div>
            <div className="LabelText" id="target">
              {data.text}
            </div>
            <LockIcon className="lockIcon" />
            <span id={data.type}></span>
          </div>
        ) : (
          <div>
            {data.text}
            <span id={data.text}></span>
          </div>
        )}

        <div>
          {data.isCodeGenerated
            ? codegeneratestatus(data.isCodeGenerated)
            : null}
        </div>
      </div>
    );
  }

  return (
    <div className="App">
      <div>
        <TreeViewComponent delayUpdate="true"
          nodeTemplate={nodeTemplate}
          id="target"
          fields={treeViewFields}
          nodeSelected={nodeSelected}
        />
      
      </div>
    </div>
  );
}

export default App;
